using System;
using System.IO;
using System.Windows.Forms;

namespace DASearcher {
    /// <summary>
    /// Summary description for DALoad.
    /// </summary>
    public class DALoad : System.Windows.Forms.Form {
        private System.Windows.Forms.Label MapNum;
        private System.Windows.Forms.Label MaxX;
        private System.Windows.Forms.Label MaxY;
        private System.Windows.Forms.Button OkayBtn;
        private System.Windows.Forms.Button CancleBtn;
        private System.Windows.Forms.Label DAFolder;
        private System.Windows.Forms.TextBox MapNumText;
        private System.Windows.Forms.TextBox MaxXText;
        private System.Windows.Forms.TextBox MaxYText;
        private System.Windows.Forms.TextBox DAFolderText;

        private MainFrame MainParent;
        private System.Windows.Forms.Button MapInfoBtn;

        private Button LoadCur;
        bool AutoLoad = false;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public DALoad(MainFrame MainF, bool AutoLoad) {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            if(!Directory.Exists(MainF.DAMapFolder)) {
                if(Directory.Exists(@"C:\Program Files\KRU\Dark Ages\maps\")) MainF.DAMapFolder = @"C:\Program Files\KRU\Dark Ages\maps\";
                else if(Directory.Exists(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) + @"\VirtualStore\Program Files (x86)\KRU\Dark Ages\maps\")) MainF.DAMapFolder = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) + @"\VirtualStore\Program Files (x86)\KRU\Dark Ages\maps\";
                else if(Directory.Exists(Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) + @"\VirtualStore\Program Files\KRU\Dark Ages\maps\")) MainF.DAMapFolder = Environment.GetFolderPath(Environment.SpecialFolder.LocalApplicationData) + @"\VirtualStore\Program Files\KRU\Dark Ages\maps\";
            }
            DAFolderText.Text = MainF.DAMapFolder;

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
            MainParent = MainF;
            this.AutoLoad = AutoLoad;
            if(AutoLoad) {
                LoadCur_Click(null, null);
                if(GotPerfectSqrt) OkayBtn_Click(null, null);
                else this.Show();
            }
        }


        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing) {
            if(disposing) {
                if(components != null) {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DALoad));
            this.MapNumText = new System.Windows.Forms.TextBox();
            this.MapNum = new System.Windows.Forms.Label();
            this.MaxX = new System.Windows.Forms.Label();
            this.MaxY = new System.Windows.Forms.Label();
            this.MaxXText = new System.Windows.Forms.TextBox();
            this.MaxYText = new System.Windows.Forms.TextBox();
            this.OkayBtn = new System.Windows.Forms.Button();
            this.CancleBtn = new System.Windows.Forms.Button();
            this.DAFolder = new System.Windows.Forms.Label();
            this.DAFolderText = new System.Windows.Forms.TextBox();
            this.MapInfoBtn = new System.Windows.Forms.Button();
            this.LoadCur = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // MapNumText
            // 
            this.MapNumText.Location = new System.Drawing.Point(72, 48);
            this.MapNumText.Name = "MapNumText";
            this.MapNumText.Size = new System.Drawing.Size(96, 20);
            this.MapNumText.TabIndex = 0;
            // 
            // MapNum
            // 
            this.MapNum.Location = new System.Drawing.Point(-8, 48);
            this.MapNum.Name = "MapNum";
            this.MapNum.Size = new System.Drawing.Size(80, 20);
            this.MapNum.TabIndex = 1;
            this.MapNum.Text = "Map Number:";
            this.MapNum.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // MaxX
            // 
            this.MaxX.Location = new System.Drawing.Point(-8, 80);
            this.MaxX.Name = "MaxX";
            this.MaxX.Size = new System.Drawing.Size(80, 20);
            this.MaxX.TabIndex = 2;
            this.MaxX.Text = "Max X:";
            this.MaxX.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // MaxY
            // 
            this.MaxY.Location = new System.Drawing.Point(-8, 112);
            this.MaxY.Name = "MaxY";
            this.MaxY.Size = new System.Drawing.Size(80, 20);
            this.MaxY.TabIndex = 3;
            this.MaxY.Text = "Max Y:";
            this.MaxY.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // MaxXText
            // 
            this.MaxXText.Location = new System.Drawing.Point(72, 80);
            this.MaxXText.Name = "MaxXText";
            this.MaxXText.Size = new System.Drawing.Size(96, 20);
            this.MaxXText.TabIndex = 4;
            // 
            // MaxYText
            // 
            this.MaxYText.Location = new System.Drawing.Point(72, 112);
            this.MaxYText.Name = "MaxYText";
            this.MaxYText.Size = new System.Drawing.Size(96, 20);
            this.MaxYText.TabIndex = 5;
            // 
            // OkayBtn
            // 
            this.OkayBtn.Location = new System.Drawing.Point(8, 144);
            this.OkayBtn.Name = "OkayBtn";
            this.OkayBtn.Size = new System.Drawing.Size(48, 24);
            this.OkayBtn.TabIndex = 6;
            this.OkayBtn.Text = "Load";
            this.OkayBtn.Click += new System.EventHandler(this.OkayBtn_Click);
            // 
            // CancleBtn
            // 
            this.CancleBtn.Location = new System.Drawing.Point(184, 144);
            this.CancleBtn.Name = "CancleBtn";
            this.CancleBtn.Size = new System.Drawing.Size(48, 24);
            this.CancleBtn.TabIndex = 7;
            this.CancleBtn.Text = "Cancel";
            this.CancleBtn.Click += new System.EventHandler(this.CancleBtn_Click);
            // 
            // DAFolder
            // 
            this.DAFolder.Location = new System.Drawing.Point(-8, 16);
            this.DAFolder.Name = "DAFolder";
            this.DAFolder.Size = new System.Drawing.Size(80, 20);
            this.DAFolder.TabIndex = 8;
            this.DAFolder.Text = "DAMap Folder";
            this.DAFolder.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
            // 
            // DAFolderText
            // 
            this.DAFolderText.Anchor = System.Windows.Forms.AnchorStyles.Right;
            this.DAFolderText.Location = new System.Drawing.Point(72, 16);
            this.DAFolderText.Name = "DAFolderText";
            this.DAFolderText.Size = new System.Drawing.Size(168, 20);
            this.DAFolderText.TabIndex = 9;
            // 
            // MapInfoBtn
            // 
            this.MapInfoBtn.Location = new System.Drawing.Point(72, 144);
            this.MapInfoBtn.Name = "MapInfoBtn";
            this.MapInfoBtn.Size = new System.Drawing.Size(96, 24);
            this.MapInfoBtn.TabIndex = 10;
            this.MapInfoBtn.Text = "Map Information";
            this.MapInfoBtn.Click += new System.EventHandler(this.MapInfoBtn_Click);
            // 
            // LoadCur
            // 
            this.LoadCur.Location = new System.Drawing.Point(184, 51);
            this.LoadCur.Name = "LoadCur";
            this.LoadCur.Size = new System.Drawing.Size(47, 80);
            this.LoadCur.TabIndex = 11;
            this.LoadCur.Text = "Get Curr Map Info";
            this.LoadCur.UseVisualStyleBackColor = true;
            this.LoadCur.Click += new System.EventHandler(this.LoadCur_Click);
            // 
            // DALoad
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(242, 178);
            this.Controls.Add(this.LoadCur);
            this.Controls.Add(this.MapInfoBtn);
            this.Controls.Add(this.DAFolderText);
            this.Controls.Add(this.MaxYText);
            this.Controls.Add(this.MaxXText);
            this.Controls.Add(this.MapNumText);
            this.Controls.Add(this.DAFolder);
            this.Controls.Add(this.CancleBtn);
            this.Controls.Add(this.OkayBtn);
            this.Controls.Add(this.MaxY);
            this.Controls.Add(this.MaxX);
            this.Controls.Add(this.MapNum);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "DALoad";
            this.Text = "Load DA Map";
            this.Closed += new System.EventHandler(this.DALoad_Closed);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        private void OkayBtn_Click(object sender, System.EventArgs e) {
            if(DAFolderText.Text == "" || MapNumText.Text == "" || MaxXText.Text == "" || MaxYText.Text == "") {
                MessageBox.Show("Please Make sure all Box's are Filled");
                return;
            }

            int MapNum = 0;
            int GivenX = 0;
            int GivenY = 0;
            try {
                MapNum = Convert.ToInt32(MapNumText.Text);
                GivenX = Convert.ToInt32(MaxXText.Text);
                GivenY = Convert.ToInt32(MaxYText.Text);
            } catch(Exception) {
                MessageBox.Show("One of the Values arn't a Number, Please Check them Over");
                return;
            }


            MainParent.MainSearcher.mainMap = new MyDAMapLib.MyDAMap().GetMakeDAMapChar(@DAFolderText.Text + @"lod" + MapNumText.Text + ".map", (ushort)GivenX, (ushort)GivenY);
            if(MainParent.MainSearcher.mainMap != null) {
                MainParent.MainSearcher.MaxX = GivenX;
                MainParent.MainSearcher.MaxY = GivenY;
                MainParent.MainSearcher.mapLoaded = int.Parse(MapNumText.Text);
                if(MainParent.DAMapFolder != DAFolderText.Text) MainParent.DAMapFolder = DAFolderText.Text;
                this.Close();
            } else MessageBox.Show("Map " + MapNumText.Text + " Not Loaded Exactly.  Check Dimentions");
        }

        public bool GotPerfectSqrt = false;
        private void MapInfoBtn_Click(object sender, System.EventArgs e) {
            GotPerfectSqrt = false;
            if(DAFolderText.Text == "" || MapNumText.Text == "") {
                MessageBox.Show("Please Make sure DAFolder and MapNumer are Filled!");
                return;
            }

            int MapNum = 0;
            try {
                MapNum = Convert.ToInt32(MapNumText.Text);
            } catch(Exception) {
                MessageBox.Show("Map Number isn't a Number, Please Check it Over");
                return;
            }


            FileInfo mapFile = new FileInfo(@DAFolderText.Text + @"lod" + MapNumText.Text + ".map");
            if(mapFile.Exists) {
                long NumOfBlocks = mapFile.Length / 6;
                double SQRTRootAsFloat = Math.Sqrt(NumOfBlocks);
                int SQRTRootAsInt = (int)Math.Round(SQRTRootAsFloat);
                string Message = "Can't be a Square; Manually Set the Values.";

                if(SQRTRootAsFloat == SQRTRootAsInt) {
                    MaxXText.Text = SQRTRootAsInt.ToString();
                    MaxYText.Text = SQRTRootAsInt.ToString();
                    Message = "Can be a " + SQRTRootAsInt.ToString() + "x" + SQRTRootAsFloat.ToString() + " Square; Setting Values.";
                    GotPerfectSqrt = true;
                }

                if(GotPerfectSqrt && !AutoLoad) {
                    MessageBox.Show(NumOfBlocks.ToString() + " Total Blocks.\n"
                        + SQRTRootAsFloat.ToString() + " is the Square Root.\n"
                        + Message);
                } else if(this.Visible) {
                    MessageBox.Show(NumOfBlocks.ToString() + " Total Blocks.\n"
                        + SQRTRootAsFloat.ToString() + " is the Square Root.\n"
                        + "Please fill in X and Y dimensions manually");
                }
            } else MessageBox.Show("Map doesn't exsists, Check Map Folder");
        }

        private void CancleBtn_Click(object sender, System.EventArgs e) {
            this.Close();
        }

        private void DALoad_Closed(object sender, System.EventArgs e) {
            MainParent.LoadDAMapBtn.Enabled = true;
        }

        private void LoadCur_Click(object sender, EventArgs e) {
            if(MainParent.MainSearcher.StartProcessCheck()) {
                MainParent.MainSearcher.UpdateValues();
                MapNumText.Text = MainParent.MainSearcher.MapNum.ToString();
                MapInfoBtn_Click(null, null);
            }
        }
    }
}