using System;
using System.Runtime.InteropServices;
using System.Threading;
using System.Windows.Forms;
using System.Xml.Linq;

namespace DASearcher {
    /// <summary>
    /// Summary description for MainFrame.
    /// </summary>
    public class MainFrame : System.Windows.Forms.Form {
        private System.Windows.Forms.NotifyIcon DASearcherSysTray;
        private System.ComponentModel.IContainer components;
        private System.Windows.Forms.ContextMenu DASearcherContextMenu;
        private System.Windows.Forms.MenuItem StartBtn;
        public System.Windows.Forms.MenuItem StopBtn;
        private System.Windows.Forms.MenuItem CreatePathBtn;
        private System.Windows.Forms.MenuItem PathStartBtn;
        public System.Windows.Forms.MenuItem PathStopBtn;
        private System.Windows.Forms.MenuItem MapOpBtn;
        private System.Windows.Forms.MenuItem ClearMapBtn;
        private System.Windows.Forms.MenuItem ClearSearchedBtn;
        private System.Windows.Forms.MenuItem ManualOpBtn;
        private System.Windows.Forms.MenuItem ShowCurrInfoBtn;
        public System.Windows.Forms.MenuItem LoadDAMapBtn;
        private System.Windows.Forms.MenuItem LoadMapBtn;
        private System.Windows.Forms.MenuItem LoadMapFromFileBtn;
        private System.Windows.Forms.MenuItem SaveMapBtn;
        public System.Windows.Forms.MenuItem HelpBtn;
        private System.Windows.Forms.MenuItem ExitBtn;
        private System.Windows.Forms.MenuItem Seperator1;
        private System.Windows.Forms.MenuItem Seperator2;
        private System.Windows.Forms.MenuItem Seperator3;
        private System.Windows.Forms.MenuItem PreviewEditMapBtn;
        public System.Windows.Forms.MenuItem ConvertMapBtn;
        public System.Windows.Forms.MenuItem WalkingDelayBtn;
        private System.Windows.Forms.MenuItem StopBeeperToggle;

        public Searcher MainSearcher;
        private Thread MainSearcherT;
        ushort StartHotKey = 0;
        ushort StopHotKey = 0;
        public MenuItem AutoLoad;
        public MenuItem LBLAutoClear;
        private MenuItem setDAMap;
        bool CleanedHotKeys = false;
        public string DAMapFolder;


        /*ATOM GlobalAddAtom(
            LPCTSTR lpString
        );*/
        [DllImport("kernel32")]
        private static extern ushort GlobalAddAtom(string lpString);
        /*ATOM GlobalDeleteAtom(
            ATOM nAtom
        );*/
        [DllImport("kernel32")]
        private static extern ushort GlobalDeleteAtom(ushort nAtom);
        /*BOOL PostMessage(
            HWND hWnd,
            UINT Msg,
            WPARAM wParam,
            LPARAM lParam
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool PostMessage(IntPtr hWnd, uint Msg, UIntPtr wParam, UIntPtr lParam);
        /*BOOL RegisterHotKey(
            HWND hWnd,
            int id,
            UINT fsModifiers,
            UINT vk
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool RegisterHotKey(IntPtr hWnd, int id, uint fsModifiers, uint vk);
        /*BOOL UnregisterHotKey(
            HWND hWnd,
            int id
        );*/
        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        private static extern bool UnregisterHotKey(IntPtr hWnd, int id);
        /*LONG_PTR GetWindowLongPtr(
            HWND hWnd,
            int nIndex
        );*/
        private static IntPtr GetWindowLongPtr(IntPtr hWnd, int nIndex) {
            if(IntPtr.Size == 8) return GetWindowLongPtr64(hWnd, nIndex);
            else return new IntPtr(GetWindowLong32(hWnd, nIndex));
        }
        [DllImport("user32.dll", EntryPoint = "GetWindowLong")]
        private static extern int GetWindowLong32(IntPtr hWnd, int nIndex);
        [DllImport("user32.dll", EntryPoint = "GetWindowLongPtr")]
        private static extern IntPtr GetWindowLongPtr64(IntPtr hWnd, int nIndex);
        /*LONG_PTR SetWindowLongPtr(
            HWND hWnd,
            int nIndex,
            LONG_PTR dwNewLong
        );*/
        private static IntPtr SetWindowLongPtr(IntPtr hWnd, int nIndex, IntPtr dwNewLong) {
            if(IntPtr.Size == 8) return SetWindowLongPtr64(hWnd, nIndex, dwNewLong);
            else return new IntPtr(SetWindowLong32(hWnd, nIndex, (int)dwNewLong));
        }
        [DllImport("user32.dll", EntryPoint = "SetWindowLong")]
        private static extern int SetWindowLong32(IntPtr hWnd, int nIndex, int dwNewLong);
        [DllImport("user32.dll", EntryPoint = "SetWindowLongPtr")]
        private static extern IntPtr SetWindowLongPtr64(IntPtr hWnd, int nIndex, IntPtr dwNewLong);


        public MainFrame() {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
            DASearcherSysTray.Icon = MyResources.Resources.Wizard2_S;

            if(!System.IO.File.Exists("DAData.xml")) { MessageBox.Show("DAData.xml file not found: Download the file from www.da-wizard.com."); Environment.Exit(0); }

            DAMapFolder = XElement.Load("DAData.xml").Element("Data").Element("MapFolder").Value;

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
            SetWindowLongPtr(this.Handle, -20, (IntPtr)(((ulong)GetWindowLongPtr(this.Handle, -20) | 0x00000080u) & ~0x00040000u)); //WS_EX_TOOLWINDOW = 0x00000080  &&  GWL_EXSTYLE = (-20)  &&  WS_EX_APPWINDOW = 0x00040000;
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing) {
            if(disposing) {
                if(components != null) {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
            this.components = new System.ComponentModel.Container();
            this.DASearcherSysTray = new System.Windows.Forms.NotifyIcon(this.components);
            this.DASearcherContextMenu = new System.Windows.Forms.ContextMenu();
            this.StartBtn = new System.Windows.Forms.MenuItem();
            this.StopBtn = new System.Windows.Forms.MenuItem();
            this.Seperator1 = new System.Windows.Forms.MenuItem();
            this.CreatePathBtn = new System.Windows.Forms.MenuItem();
            this.PathStartBtn = new System.Windows.Forms.MenuItem();
            this.PathStopBtn = new System.Windows.Forms.MenuItem();
            this.MapOpBtn = new System.Windows.Forms.MenuItem();
            this.PreviewEditMapBtn = new System.Windows.Forms.MenuItem();
            this.ClearMapBtn = new System.Windows.Forms.MenuItem();
            this.ClearSearchedBtn = new System.Windows.Forms.MenuItem();
            this.AutoLoad = new System.Windows.Forms.MenuItem();
            this.LBLAutoClear = new System.Windows.Forms.MenuItem();
            this.ManualOpBtn = new System.Windows.Forms.MenuItem();
            this.setDAMap = new System.Windows.Forms.MenuItem();
            this.ShowCurrInfoBtn = new System.Windows.Forms.MenuItem();
            this.ConvertMapBtn = new System.Windows.Forms.MenuItem();
            this.WalkingDelayBtn = new System.Windows.Forms.MenuItem();
            this.StopBeeperToggle = new System.Windows.Forms.MenuItem();
            this.Seperator2 = new System.Windows.Forms.MenuItem();
            this.LoadMapBtn = new System.Windows.Forms.MenuItem();
            this.LoadDAMapBtn = new System.Windows.Forms.MenuItem();
            this.LoadMapFromFileBtn = new System.Windows.Forms.MenuItem();
            this.SaveMapBtn = new System.Windows.Forms.MenuItem();
            this.Seperator3 = new System.Windows.Forms.MenuItem();
            this.HelpBtn = new System.Windows.Forms.MenuItem();
            this.ExitBtn = new System.Windows.Forms.MenuItem();
            this.SuspendLayout();
            // 
            // DASearcherSysTray
            // 
            this.DASearcherSysTray.ContextMenu = this.DASearcherContextMenu;
            this.DASearcherSysTray.Text = "DASearcher";
            this.DASearcherSysTray.Visible = true;
            this.DASearcherSysTray.DoubleClick += new System.EventHandler(this.DASearcherSysTray_DoubleClick);
            // 
            // DASearcherContextMenu
            // 
            this.DASearcherContextMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.StartBtn,
            this.StopBtn,
            this.Seperator1,
            this.CreatePathBtn,
            this.MapOpBtn,
            this.ManualOpBtn,
            this.Seperator2,
            this.LoadMapBtn,
            this.SaveMapBtn,
            this.Seperator3,
            this.HelpBtn,
            this.ExitBtn});
            // 
            // StartBtn
            // 
            this.StartBtn.Index = 0;
            this.StartBtn.Shortcut = System.Windows.Forms.Shortcut.CtrlIns;
            this.StartBtn.Text = "Start / Resume Search";
            this.StartBtn.Click += new System.EventHandler(this.StartBtn_Click);
            // 
            // StopBtn
            // 
            this.StopBtn.Enabled = false;
            this.StopBtn.Index = 1;
            this.StopBtn.Shortcut = System.Windows.Forms.Shortcut.CtrlDel;
            this.StopBtn.Text = "Stop / Pause Search";
            this.StopBtn.Click += new System.EventHandler(this.StopBtn_Click);
            // 
            // Seperator1
            // 
            this.Seperator1.Index = 2;
            this.Seperator1.Text = "-";
            // 
            // CreatePathBtn
            // 
            this.CreatePathBtn.Index = 3;
            this.CreatePathBtn.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.PathStartBtn,
            this.PathStopBtn});
            this.CreatePathBtn.Text = "Create Path Search";
            // 
            // PathStartBtn
            // 
            this.PathStartBtn.Index = 0;
            this.PathStartBtn.Text = "Start Path";
            this.PathStartBtn.Click += new System.EventHandler(this.PathStartBtn_Click);
            // 
            // PathStopBtn
            // 
            this.PathStopBtn.Enabled = false;
            this.PathStopBtn.Index = 1;
            this.PathStopBtn.Text = "End Path";
            this.PathStopBtn.Click += new System.EventHandler(this.PathStopBtn_Click);
            // 
            // MapOpBtn
            // 
            this.MapOpBtn.Index = 4;
            this.MapOpBtn.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.PreviewEditMapBtn,
            this.ClearMapBtn,
            this.ClearSearchedBtn,
            this.AutoLoad,
            this.LBLAutoClear});
            this.MapOpBtn.Text = "Map Options";
            // 
            // PreviewEditMapBtn
            // 
            this.PreviewEditMapBtn.Index = 0;
            this.PreviewEditMapBtn.Text = "Preview / Edit Map";
            this.PreviewEditMapBtn.Click += new System.EventHandler(this.PreviewEditMapBtn_Click);
            // 
            // ClearMapBtn
            // 
            this.ClearMapBtn.Index = 1;
            this.ClearMapBtn.Text = "Completely Clear Map";
            this.ClearMapBtn.Click += new System.EventHandler(this.ClearMapBtn_Click);
            // 
            // ClearSearchedBtn
            // 
            this.ClearSearchedBtn.Index = 2;
            this.ClearSearchedBtn.Text = "Clear Searched Areas";
            this.ClearSearchedBtn.Click += new System.EventHandler(this.ClearSearchedBtn_Click);
            // 
            // AutoLoad
            // 
            this.AutoLoad.Checked = true;
            this.AutoLoad.Index = 3;
            this.AutoLoad.Text = "AutoLoad Curr Map";
            this.AutoLoad.Click += new System.EventHandler(this.AutoLoad_Click);
            // 
            // LBLAutoClear
            // 
            this.LBLAutoClear.Checked = true;
            this.LBLAutoClear.Index = 4;
            this.LBLAutoClear.Text = "AutoClear (Repeat) Map";
            this.LBLAutoClear.Click += new System.EventHandler(this.LBLAutoClear_Click);
            // 
            // ManualOpBtn
            // 
            this.ManualOpBtn.Index = 5;
            this.ManualOpBtn.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.setDAMap,
            this.ShowCurrInfoBtn,
            this.ConvertMapBtn,
            this.WalkingDelayBtn,
            this.StopBeeperToggle});
            this.ManualOpBtn.Text = "Manual Options";
            // 
            // setDAMap
            // 
            this.setDAMap.Index = 0;
            this.setDAMap.Text = "Set DA Map Folder";
            this.setDAMap.Click += new System.EventHandler(this.setDAMap_Click);
            // 
            // ShowCurrInfoBtn
            // 
            this.ShowCurrInfoBtn.Index = 1;
            this.ShowCurrInfoBtn.Text = "Show Current Info";
            this.ShowCurrInfoBtn.Click += new System.EventHandler(this.ShowCurrInfoBtn_Click);
            // 
            // ConvertMapBtn
            // 
            this.ConvertMapBtn.Index = 2;
            this.ConvertMapBtn.Text = "Convert Map Axis";
            this.ConvertMapBtn.Click += new System.EventHandler(this.ConvertMapBtn_Click);
            // 
            // WalkingDelayBtn
            // 
            this.WalkingDelayBtn.Index = 3;
            this.WalkingDelayBtn.Text = "Set Walking Delay";
            this.WalkingDelayBtn.Click += new System.EventHandler(this.WalkingDelayBtn_Click);
            // 
            // StopBeeperToggle
            // 
            this.StopBeeperToggle.Checked = true;
            this.StopBeeperToggle.Index = 4;
            this.StopBeeperToggle.Text = "Toggle Stop Beeper";
            this.StopBeeperToggle.Click += new System.EventHandler(this.StopBeeperToggle_Click);
            // 
            // Seperator2
            // 
            this.Seperator2.Index = 6;
            this.Seperator2.Text = "-";
            // 
            // LoadMapBtn
            // 
            this.LoadMapBtn.Index = 7;
            this.LoadMapBtn.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.LoadDAMapBtn,
            this.LoadMapFromFileBtn});
            this.LoadMapBtn.Text = "Load Map";
            // 
            // LoadDAMapBtn
            // 
            this.LoadDAMapBtn.Index = 0;
            this.LoadDAMapBtn.Text = "Load DA Map";
            this.LoadDAMapBtn.Click += new System.EventHandler(this.LoadDAMapBtn_Click);
            // 
            // LoadMapFromFileBtn
            // 
            this.LoadMapFromFileBtn.Index = 1;
            this.LoadMapFromFileBtn.Text = "Load From File";
            this.LoadMapFromFileBtn.Click += new System.EventHandler(this.LoadMapFromFileBtn_Click);
            // 
            // SaveMapBtn
            // 
            this.SaveMapBtn.Index = 8;
            this.SaveMapBtn.Text = "Save Map";
            this.SaveMapBtn.Click += new System.EventHandler(this.SaveMapBtn_Click);
            // 
            // Seperator3
            // 
            this.Seperator3.Index = 9;
            this.Seperator3.Text = "-";
            // 
            // HelpBtn
            // 
            this.HelpBtn.DefaultItem = true;
            this.HelpBtn.Index = 10;
            this.HelpBtn.Text = "Help";
            this.HelpBtn.Click += new System.EventHandler(this.HelpBtn_Click);
            // 
            // ExitBtn
            // 
            this.ExitBtn.Index = 11;
            this.ExitBtn.Text = "Exit";
            this.ExitBtn.Click += new System.EventHandler(this.ExitBtn_Click);
            // 
            // MainFrame
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(100, 57);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None;
            this.Name = "MainFrame";
            this.ShowInTaskbar = false;
            this.Text = "DASearcher";
            this.WindowState = System.Windows.Forms.FormWindowState.Minimized;
            this.Load += new System.EventHandler(this.MainFrame_Load);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.MainFrame_Closing);
            this.ResumeLayout(false);

        }
        #endregion

        [STAThread]
        static void Main() {
            if(System.Diagnostics.Process.GetProcessesByName("DASearcher").Length == 2) return;
            AppDomain.CurrentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyUnhandledEx);
            Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(MyThreadingEx);

            Application.Run(new MainFrame());
        }

        static void MyUnhandledEx(object sender, UnhandledExceptionEventArgs args) {
            using(System.IO.StreamWriter sw = new System.IO.StreamWriter("CrashLogUnhandledEx (DASearcher " + Application.ProductVersion + ") " + DateTime.Now.ToString("u", System.Globalization.CultureInfo.InvariantCulture).TrimEnd('Z').Replace(":", "-") + ".txt", true)) sw.WriteLine(((Exception)args.ExceptionObject).ToString());
            Environment.Exit(0);
        }

        static void MyThreadingEx(object sender, ThreadExceptionEventArgs args) {
            using(System.IO.StreamWriter sw = new System.IO.StreamWriter("CrashLogThreadingEx (DASearcher " + Application.ProductVersion + ") " + DateTime.Now.ToString("u", System.Globalization.CultureInfo.InvariantCulture).TrimEnd('Z').Replace(":", "-") + ".txt", true)) sw.WriteLine(args.Exception.ToString());
            Environment.Exit(0);
        }

        private void StartBtn_Click(object sender, System.EventArgs e) {
            if(AutoLoad.Checked) {
                if(MainSearcher.StartProcessCheck()) {
                    MainSearcher.UpdateValues();
                    if(MainSearcher.mapLoaded != MainSearcher.MapNum) {
                        LoadDAMapBtn.Enabled = false;
                        DALoad startLoad = new DALoad(this, true);
                        LoadDAMapBtn.Enabled = true;
                        if(startLoad.GotPerfectSqrt) {
                            this.StartBtn.Enabled = false;
                            this.StopBtn.Enabled = true;
                            this.PathStartBtn.Enabled = false;
                            this.PathStopBtn.Enabled = false;
                            DASearcherSysTray.Icon = MyResources.Resources.Wizard2_S_R;
                            (MainSearcherT = new Thread(new ThreadStart(MainSearcher.StartSearch))).Start();
                        }
                    } else {
                        this.StartBtn.Enabled = false;
                        this.StopBtn.Enabled = true;
                        this.PathStartBtn.Enabled = false;
                        this.PathStopBtn.Enabled = false;
                        DASearcherSysTray.Icon = MyResources.Resources.Wizard2_S_R;
                        (MainSearcherT = new Thread(new ThreadStart(MainSearcher.StartSearch))).Start();
                    }
                }
            } else {
                this.StartBtn.Enabled = false;
                this.StopBtn.Enabled = true;
                this.PathStartBtn.Enabled = false;
                this.PathStopBtn.Enabled = false;
                DASearcherSysTray.Icon = MyResources.Resources.Wizard2_S_R;
                (MainSearcherT = new Thread(new ThreadStart(MainSearcher.StartSearch))).Start();
            }
        }

        public void StopBtn_Click(object sender, System.EventArgs e) {
            this.StartBtn.Enabled = true;
            this.StopBtn.Enabled = false;
            this.PathStartBtn.Enabled = true;

            MainSearcher.Running = false;
            DASearcherSysTray.Icon = MyResources.Resources.Wizard2_S;

            if(StopBeeperToggle.Checked) System.Console.Beep(600, 250);
            MainSearcherT.Abort();

            if(PathStopBtn.Enabled) MainSearcher.PathSearcherConvert();
            PathStopBtn.Enabled = false;
        }

        private void PathStartBtn_Click(object sender, System.EventArgs e) {
            if(AutoLoad.Checked) {
                if(MainSearcher.StartProcessCheck()) {
                    MainSearcher.UpdateValues();
                    if(MainSearcher.mapLoaded != MainSearcher.MapNum) {
                        LoadDAMapBtn.Enabled = false;
                        DALoad startLoad = new DALoad(this, true);
                        LoadDAMapBtn.Enabled = true;
                        if(startLoad.GotPerfectSqrt) {
                            MainSearcherT = new Thread(new ThreadStart(MainSearcher.PathSearcher));
                            StartBtn.Enabled = false;
                            StopBtn.Enabled = true;
                            PathStartBtn.Enabled = false;
                            PathStopBtn.Enabled = true;
                            MainSearcherT.Start();
                        }
                    } else {
                        MainSearcherT = new Thread(new ThreadStart(MainSearcher.PathSearcher));
                        StartBtn.Enabled = false;
                        StopBtn.Enabled = true;
                        PathStartBtn.Enabled = false;
                        PathStopBtn.Enabled = true;
                        MainSearcherT.Start();
                    }
                }
            } else {
                MainSearcherT = new Thread(new ThreadStart(MainSearcher.PathSearcher));
                StartBtn.Enabled = false;
                StopBtn.Enabled = true;
                PathStartBtn.Enabled = false;
                PathStopBtn.Enabled = true;
                MainSearcherT.Start();
            }
        }

        public void PathStopBtn_Click(object sender, System.EventArgs e) {
            if(StopBtn.Enabled) StopBtn_Click(null, null);
        }

        private void SaveMapBtn_Click(object sender, System.EventArgs e) {
            SaveFileDialog saveFileDialog1 = new SaveFileDialog();

            saveFileDialog1.Filter = "map files (*.map)|*.map|All files (*.*)|*.*";
            saveFileDialog1.FilterIndex = 1;
            saveFileDialog1.InitialDirectory = Application.StartupPath;
            saveFileDialog1.RestoreDirectory = true;

            if(saveFileDialog1.ShowDialog() == DialogResult.OK) MainSearcher.SaveMap(saveFileDialog1.FileName);
        }

        public void LoadMapFromFileBtn_Click(object sender, System.EventArgs e) {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            openFileDialog1.Filter = "map files (*.map)|*.map|All files (*.*)|*.*";
            openFileDialog1.FilterIndex = 1;
            openFileDialog1.InitialDirectory = Application.StartupPath;
            openFileDialog1.RestoreDirectory = true;

            if(openFileDialog1.ShowDialog() == DialogResult.OK) MainSearcher.LoadSavedMap(openFileDialog1.FileName);
        }

        private void LoadDAMapBtn_Click(object sender, System.EventArgs e) {
            LoadDAMapBtn.Enabled = false;

            DALoad StartLoad = new DALoad(this, false);
            StartLoad.Show();
        }

        private void HelpBtn_Click(object sender, System.EventArgs e) {
            if(HelpBtn.Enabled == true) {
                HelpBtn.Enabled = false;

                Help HelpMenu = new Help(this);
                HelpMenu.Show();
            }
        }

        private void DASearcherSysTray_DoubleClick(object sender, EventArgs e) {
            HelpBtn_Click(null, null);
        }

        private void ClearMapBtn_Click(object sender, System.EventArgs e) {
            MainSearcher.ClearMap();
            MessageBox.Show("Entire Map Cleared");
        }

        private void ClearSearchedBtn_Click(object sender, System.EventArgs e) {
            MainSearcher.ClearSearched();
            MessageBox.Show("Searched Portion of Max Cleared");
        }

        private void ShowCurrInfoBtn_Click(object sender, System.EventArgs e) {
            if(MainSearcher.StartProcessCheck()) {
                MainSearcher.UpdateValues();
                MessageBox.Show("MapNumber is " + MainSearcher.MapNum.ToString() + ". Your X is " + MainSearcher.X.ToString() + " and your Y is " + MainSearcher.Y.ToString() + ".");
            }
        }

        private void ConvertMapBtn_Click(object sender, System.EventArgs e) {
            ConvertMapBtn.Enabled = false;

            ConvertMap StartConvert = new ConvertMap(this);
            StartConvert.Show();
        }

        private void PreviewEditMapBtn_Click(object sender, System.EventArgs e) {
            MapEditor EditMenu = new MapEditor(this);
            EditMenu.Show();
        }

        private void WalkingDelayBtn_Click(object sender, System.EventArgs e) {
            WalkingDelayBtn.Enabled = false;

            ChangeWalking StartChangeWalking = new ChangeWalking(this);
            StartChangeWalking.Show();
        }

        private void StopBeeperToggle_Click(object sender, System.EventArgs e) {
            StopBeeperToggle.Checked = !StopBeeperToggle.Checked;
        }

        private void ExitBtn_Click(object sender, System.EventArgs e) {
            if(StopBtn.Enabled) StopBtn_Click(null, null);
            Application.Exit();
        }

        // WM_HOTKEY = 0x312;
        protected override void WndProc(ref Message m) {
            if(m.Msg == 0x312) {
                if((ushort)m.WParam == StartHotKey) {
                    if(StartBtn.Enabled) StartBtn_Click(null, null);
                } else if((ushort)m.WParam == StopHotKey) {
                    if(StopBtn.Enabled) StopBtn_Click(null, null);
                }
            }
            base.WndProc(ref m);
        }

        private void MainFrame_Load(object sender, System.EventArgs e) {
            MainSearcher = new Searcher(this);

            StartHotKey = GlobalAddAtom("StartSearch_1000");
            StopHotKey = GlobalAddAtom("StopSearch_1001");
            if(StartHotKey == 0 || StopHotKey == 0) MessageBox.Show("Wasn't Able to Add Hotkey Atoms");
            else {
                // MOD_ALT = 0x1;	MOD_CONTROL = 0x2;	MOD_SHIFT = 0x4;	MOD_WIN = 0x8;
                bool Suc1 = RegisterHotKey(Handle, StartHotKey, 0x2, (int)Keys.Insert);
                bool Suc2 = RegisterHotKey(Handle, StopHotKey, 0x2, (int)Keys.Delete);
                if(!Suc2 || !Suc2) {
                    GlobalDeleteAtom(StartHotKey);
                    GlobalDeleteAtom(StopHotKey);
                    CleanedHotKeys = true;
                    MessageBox.Show("Wasn't Able to Register Hotkeys!");
                }
            }
        }

        private void MainFrame_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            try { MainSearcher.pReader.Dispose(); MainSearcher.Running = false; Thread.Sleep(15); if(MainSearcherT.IsAlive) MainSearcherT.Abort(); } catch(Exception) { }

            if(!CleanedHotKeys) {
                UnregisterHotKey(Handle, StartHotKey);
                UnregisterHotKey(Handle, StopHotKey);
                GlobalDeleteAtom(StartHotKey);
                GlobalDeleteAtom(StopHotKey);
            }
        }

        private void AutoLoad_Click(object sender, EventArgs e) {
            AutoLoad.Checked = !AutoLoad.Checked;
        }

        private void LBLAutoClear_Click(object sender, EventArgs e) {
            LBLAutoClear.Checked = !LBLAutoClear.Checked;
        }

        private void setDAMap_Click(object sender, EventArgs e) {
            SetDAMap setMap = new SetDAMap();
            setMap.tbDAFolder.Text = DAMapFolder;
            setMap.MyParentForm = this;
            if(setMap.ShowDialog() == DialogResult.OK) {
                DAMapFolder = setMap.tbDAFolder.Text;
                XElement myXML = XElement.Load("DAData.xml");
                myXML.Element("Data").Element("MapFolder").SetValue(DAMapFolder);
                myXML.Save("DAData.xml");
            }
        }
    }
}