using System;
using System.Windows.Forms;

namespace DASearcher {
    /// <summary>
    /// Summary description for MapEditor.
    /// </summary>
    public class MapEditor : System.Windows.Forms.Form {
        private MainFrame MainParent;
        private System.Windows.Forms.RichTextBox MainTextBox;
        private System.Windows.Forms.Button SaveBtn;
        private System.Windows.Forms.Button UpdateBtn;
        private System.Windows.Forms.Button CancleBtn;
        private Button BTNLoad;

        /// <summary>
        /// Required designer variable.
        /// </summary>
        private System.ComponentModel.Container components = null;

        public MapEditor(MainFrame MainF) {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call
            //
            MainParent = MainF;
        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing) {
            if(disposing) {
                if(components != null) {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent() {
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MapEditor));
            this.MainTextBox = new System.Windows.Forms.RichTextBox();
            this.SaveBtn = new System.Windows.Forms.Button();
            this.UpdateBtn = new System.Windows.Forms.Button();
            this.CancleBtn = new System.Windows.Forms.Button();
            this.BTNLoad = new System.Windows.Forms.Button();
            this.SuspendLayout();
            // 
            // MainTextBox
            // 
            this.MainTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.MainTextBox.Font = new System.Drawing.Font("Lucida Console", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.MainTextBox.Location = new System.Drawing.Point(8, 8);
            this.MainTextBox.Name = "MainTextBox";
            this.MainTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.ForcedBoth;
            this.MainTextBox.Size = new System.Drawing.Size(528, 448);
            this.MainTextBox.TabIndex = 0;
            this.MainTextBox.Text = "";
            this.MainTextBox.WordWrap = false;
            // 
            // SaveBtn
            // 
            this.SaveBtn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.SaveBtn.Location = new System.Drawing.Point(544, 352);
            this.SaveBtn.Name = "SaveBtn";
            this.SaveBtn.Size = new System.Drawing.Size(64, 48);
            this.SaveBtn.TabIndex = 1;
            this.SaveBtn.Text = "Save To Current";
            this.SaveBtn.Click += new System.EventHandler(this.SaveBtn_Click);
            // 
            // UpdateBtn
            // 
            this.UpdateBtn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.UpdateBtn.Location = new System.Drawing.Point(544, 296);
            this.UpdateBtn.Name = "UpdateBtn";
            this.UpdateBtn.Size = new System.Drawing.Size(64, 48);
            this.UpdateBtn.TabIndex = 2;
            this.UpdateBtn.Text = "Show Current Loaded";
            this.UpdateBtn.Click += new System.EventHandler(this.UpdateBtn_Click);
            // 
            // CancleBtn
            // 
            this.CancleBtn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.CancleBtn.Location = new System.Drawing.Point(544, 408);
            this.CancleBtn.Name = "CancleBtn";
            this.CancleBtn.Size = new System.Drawing.Size(64, 48);
            this.CancleBtn.TabIndex = 3;
            this.CancleBtn.Text = "Cancel";
            this.CancleBtn.Click += new System.EventHandler(this.CancleBtn_Click);
            // 
            // BTNLoad
            // 
            this.BTNLoad.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.BTNLoad.Location = new System.Drawing.Point(544, 242);
            this.BTNLoad.Name = "BTNLoad";
            this.BTNLoad.Size = new System.Drawing.Size(64, 48);
            this.BTNLoad.TabIndex = 4;
            this.BTNLoad.Text = "Load Current Map";
            this.BTNLoad.UseVisualStyleBackColor = true;
            this.BTNLoad.Click += new System.EventHandler(this.Load_Click);
            // 
            // MapEditor
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(616, 461);
            this.Controls.Add(this.BTNLoad);
            this.Controls.Add(this.CancleBtn);
            this.Controls.Add(this.UpdateBtn);
            this.Controls.Add(this.SaveBtn);
            this.Controls.Add(this.MainTextBox);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Name = "MapEditor";
            this.Text = "MapEditor";
            this.ResumeLayout(false);

        }
        #endregion


        private void UpdateBtn_Click(object sender, System.EventArgs e) {
            UpdateBtn.Enabled = false;
            MainTextBox.Text = "";
            System.Text.StringBuilder mapBuilder = new System.Text.StringBuilder(MainParent.MainSearcher.MaxY * MainParent.MainSearcher.MaxX);

            for(int i = 0; i < MainParent.MainSearcher.MaxY; i++) {
                for(int c = 0; c < MainParent.MainSearcher.MaxX; c++) {
                    if(MainParent.MainSearcher.mainMap[c, i] == 0) mapBuilder.Append(" ");
                    else mapBuilder.Append(MainParent.MainSearcher.mainMap[c, i]);
                }
                mapBuilder.Append("\n");
            }
            MainTextBox.Text = mapBuilder.ToString();
            UpdateBtn.Enabled = true;
        }

        private void SaveBtn_Click(object sender, System.EventArgs e) {
            if(MainTextBox.TextLength != MainParent.MainSearcher.MaxY * MainParent.MainSearcher.MaxX + MainParent.MainSearcher.MaxY) {
                MessageBox.Show("Error: Incorrect Array Size");
                return;
            } else {
                char[] MainChar = MainTextBox.Text.ToCharArray();
                int i = 0;
                int c = 0;

                for(int d = 0; d < MainChar.Length; d++) {
                    if(c > MainParent.MainSearcher.MaxX || i >= MainParent.MainSearcher.MaxY) {
                        MessageBox.Show("Error: Incorrect Array Dimensions");
                        return;
                    }
                    if(MainChar[d] == ' ') MainParent.MainSearcher.mainMap[c, i] = (char)0;
                    else if(MainChar[d] == '\n') {
                        c = -1;
                        i++;
                    } else MainParent.MainSearcher.mainMap[c, i] = MainChar[d];
                    c++;
                }
                MessageBox.Show("Map Saved to DASearcher - Ready To Search");
            }
        }

        private void CancleBtn_Click(object sender, System.EventArgs e) {
            this.Close();
        }

        private void Load_Click(object sender, EventArgs e) {
            MainParent.LoadDAMapBtn.Enabled = false;

            DALoad startLoad = new DALoad(MainParent, true);
            MainParent.LoadDAMapBtn.Enabled = true;
            if(startLoad.GotPerfectSqrt) UpdateBtn_Click(null, null);
        }
    }
}